diff -ruN vdr-1.7.18/PLUGINS/src/skincurses/skincurses.c vdr-1.7.19/PLUGINS/src/skincurses/skincurses.c
--- vdr-1.7.18/PLUGINS/src/skincurses/skincurses.c	2011-01-04 09:52:03.000000000 +0100
+++ vdr-1.7.19/PLUGINS/src/skincurses/skincurses.c	2011-05-15 23:41:47.000000000 +0200
@@ -3,7 +3,7 @@
  *
  * See the README file for copyright information and how to reach the author.
  *
- * $Id: skincurses.c 2.5 2011/01/04 08:52:03 kls Exp $
+ * $Id: skincurses.c 2.6 2011/05/15 21:41:47 kls Exp $
  */
 
 #include <ncurses.h>
@@ -11,7 +11,7 @@
 #include <vdr/plugin.h>
 #include <vdr/skins.h>
 
-static const char *VERSION        = "0.1.9";
+static const char *VERSION        = "0.1.10";
 static const char *DESCRIPTION    = trNOOP("A text only skin");
 static const char *MAINMENUENTRY  = NULL;
 
@@ -26,7 +26,7 @@
   virtual void DrawText(cPixmap *Pixmap, int x, int y, const char *s, tColor ColorFg, tColor ColorBg, int Width) const {}
   };
 
-static const cCursesFont Font;
+static const cCursesFont Font = cCursesFont(); // w/o the '= cCursesFont()' gcc 4.6 complains - can anybody explain why this is necessary?
 
 // --- cCursesOsd ------------------------------------------------------------
 
diff -ruN vdr-1.7.18/ci.c vdr-1.7.19/ci.c
--- vdr-1.7.18/ci.c	2010-01-02 11:39:50.000000000 +0100
+++ vdr-1.7.19/ci.c	2011-05-21 17:21:33.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: ci.c 2.6 2010/01/02 10:39:50 kls Exp $
+ * $Id: ci.c 2.7 2011/05/21 15:21:33 kls Exp $
  */
 
 #include "ci.h"
@@ -1894,9 +1894,9 @@
 }
 
 // see ISO/IEC 13818-1
-#define STREAM_TYPE_VIDEO  0x02
-#define STREAM_TYPE_AUDIO  0x04
-#define STREAM_TYPE_DOLBY  0x06
+#define STREAM_TYPE_VIDEO    0x02
+#define STREAM_TYPE_AUDIO    0x04
+#define STREAM_TYPE_PRIVATE  0x06
 
 void cCamSlot::AddChannel(const cChannel *Channel)
 {
@@ -1910,7 +1910,9 @@
      for (const int *Apid = Channel->Apids(); *Apid; Apid++)
          AddPid(Channel->Sid(), *Apid, STREAM_TYPE_AUDIO);
      for (const int *Dpid = Channel->Dpids(); *Dpid; Dpid++)
-         AddPid(Channel->Sid(), *Dpid, STREAM_TYPE_DOLBY);
+         AddPid(Channel->Sid(), *Dpid, STREAM_TYPE_PRIVATE);
+     for (const int *Spid = Channel->Spids(); *Spid; Spid++)
+         AddPid(Channel->Sid(), *Spid, STREAM_TYPE_PRIVATE);
      }
 }
 
@@ -1931,7 +1933,9 @@
      for (const int *Apid = Channel->Apids(); *Apid; Apid++)
          CaPmt.AddPid(*Apid, STREAM_TYPE_AUDIO);
      for (const int *Dpid = Channel->Dpids(); *Dpid; Dpid++)
-         CaPmt.AddPid(*Dpid, STREAM_TYPE_DOLBY);
+         CaPmt.AddPid(*Dpid, STREAM_TYPE_PRIVATE);
+     for (const int *Spid = Channel->Spids(); *Spid; Spid++)
+         CaPmt.AddPid(*Spid, STREAM_TYPE_PRIVATE); 
      cas->SendPMT(&CaPmt);
      cTimeMs Timeout(QUERY_REPLY_TIMEOUT);
      do {
diff -ruN vdr-1.7.18/config.c vdr-1.7.19/config.c
--- vdr-1.7.18/config.c	2010-06-06 12:06:43.000000000 +0200
+++ vdr-1.7.19/config.c	2011-06-13 16:41:01.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.c 2.13 2010/06/06 10:06:43 kls Exp $
+ * $Id: config.c 2.14 2011/06/13 14:41:01 kls Exp $
  */
 
 #include "config.h"
@@ -395,7 +395,7 @@
   CurrentChannel = -1;
   CurrentVolume = MAXVOLUME;
   CurrentDolby = 0;
-  InitialChannel = 0;
+  // InitialChannel is initialized by constructor
   InitialVolume = -1;
   ChannelsWrap = 0;
   EmergencyExit = 1;
@@ -404,6 +404,7 @@
 cSetup& cSetup::operator= (const cSetup &s)
 {
   memcpy(&__BeginData__, &s.__BeginData__, (char *)&s.__EndData__ - (char *)&s.__BeginData__);
+  InitialChannel = s.InitialChannel;
   return *this;
 }
 
@@ -586,7 +587,7 @@
   else if (!strcasecmp(Name, "CurrentChannel"))      CurrentChannel     = atoi(Value);
   else if (!strcasecmp(Name, "CurrentVolume"))       CurrentVolume      = atoi(Value);
   else if (!strcasecmp(Name, "CurrentDolby"))        CurrentDolby       = atoi(Value);
-  else if (!strcasecmp(Name, "InitialChannel"))      InitialChannel     = atoi(Value);
+  else if (!strcasecmp(Name, "InitialChannel"))      InitialChannel     = Value;
   else if (!strcasecmp(Name, "InitialVolume"))       InitialVolume      = atoi(Value);
   else if (!strcasecmp(Name, "ChannelsWrap"))        ChannelsWrap       = atoi(Value);
   else if (!strcasecmp(Name, "EmergencyExit"))       EmergencyExit      = atoi(Value);
diff -ruN vdr-1.7.18/config.h vdr-1.7.19/config.h
--- vdr-1.7.18/config.h	2011-03-13 13:02:31.000000000 +0100
+++ vdr-1.7.19/config.h	2011-06-13 16:24:40.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: config.h 2.30 2011/03/13 12:02:31 kls Exp $
+ * $Id: config.h 2.32 2011/06/13 14:24:40 kls Exp $
  */
 
 #ifndef __CONFIG_H
@@ -22,13 +22,13 @@
 
 // VDR's own version number:
 
-#define VDRVERSION  "1.7.18"
-#define VDRVERSNUM   10718  // Version * 10000 + Major * 100 + Minor
+#define VDRVERSION  "1.7.19"
+#define VDRVERSNUM   10719  // Version * 10000 + Major * 100 + Minor
 
 // The plugin API's version number:
 
-#define APIVERSION  "1.7.18"
-#define APIVERSNUM   10718  // Version * 10000 + Major * 100 + Minor
+#define APIVERSION  "1.7.19"
+#define APIVERSNUM   10719  // Version * 10000 + Major * 100 + Minor
 
 // When loading plugins, VDR searches them by their APIVERSION, which
 // may be smaller than VDRVERSION in case there have been no changes to
@@ -287,11 +287,11 @@
   int CurrentChannel;
   int CurrentVolume;
   int CurrentDolby;
-  int InitialChannel;
   int InitialVolume;
   int ChannelsWrap;
   int EmergencyExit;
   int __EndData__;
+  cString InitialChannel;
   cSetup(void);
   cSetup& operator= (const cSetup &s);
   bool Load(const char *FileName);
diff -ruN vdr-1.7.18/device.c vdr-1.7.19/device.c
--- vdr-1.7.18/device.c	2011-02-25 16:12:03.000000000 +0100
+++ vdr-1.7.19/device.c	2011-06-02 15:14:16.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.c 2.38 2011/02/25 15:12:03 kls Exp $
+ * $Id: device.c 2.41 2011/06/02 13:14:16 kls Exp $
  */
 
 #include "device.h"
@@ -286,10 +286,10 @@
              imp <<= 8; imp |= min(max(device[i]->Priority() + MAXPRIORITY, 0), 0xFF);                               // use the device with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
              imp <<= 8; imp |= min(max((NumUsableSlots ? SlotPriority[j] : 0) + MAXPRIORITY, 0), 0xFF);              // use the CAM slot with the lowest priority (+MAXPRIORITY to assure that values -99..99 can be used)
              imp <<= 1; imp |= ndr;                                                                                  // avoid devices if we need to detach existing receivers
-             imp <<= 1; imp |= device[i]->IsPrimaryDevice();                                                         // avoid the primary device
              imp <<= 1; imp |= NumUsableSlots ? 0 : device[i]->HasCi();                                              // avoid cards with Common Interface for FTA channels
-             imp <<= 1; imp |= device[i]->HasDecoder();                                                              // avoid full featured cards
+             imp <<= 1; imp |= device[i]->AvoidRecording();                                                          // avoid SD full featured cards
              imp <<= 1; imp |= NumUsableSlots ? !ChannelCamRelations.CamDecrypt(Channel->GetChannelID(), j + 1) : 0; // prefer CAMs that are known to decrypt this channel
+             imp <<= 1; imp |= device[i]->IsPrimaryDevice();                                                         // avoid the primary device
              if (imp < Impact) {
                 // This device has less impact than any previous one, so we take it.
                 Impact = imp;
@@ -618,6 +618,16 @@
   return 0;
 }
 
+int cDevice::SignalStrength(void) const
+{
+  return -1;
+}
+
+int cDevice::SignalQuality(void) const
+{
+  return -1;
+}
+
 const cChannel *cDevice::GetCurrentlyTunedTransponder(void) const
 {
   return NULL;
diff -ruN vdr-1.7.18/device.h vdr-1.7.19/device.h
--- vdr-1.7.18/device.h	2011-03-21 18:58:41.000000000 +0100
+++ vdr-1.7.19/device.h	2011-06-02 15:15:31.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: device.h 2.24 2011/03/21 17:58:41 kls Exp $
+ * $Id: device.h 2.26 2011/06/02 13:15:31 kls Exp $
  */
 
 #ifndef __DEVICE_H
@@ -197,6 +197,9 @@
          ///< Returns the number of this device (0 ... numDevices).
   virtual bool HasDecoder(void) const;
          ///< Tells whether this device has an MPEG decoder.
+  virtual bool AvoidRecording(void) const { return false; }
+         ///< Returns true if this device should only be used for recording
+         ///< if no other device is available.
 
 // Device hooks
 
@@ -250,6 +253,16 @@
          ///< actually provide channels must implement this function.
          ///< The result of this function is used when selecting a device, in order
          ///< to avoid devices that provide more than one system.
+  virtual int SignalStrength(void) const;
+         ///< Returns the "strength" of the currently received signal.
+         ///< This is a value in the range 0 (no signal at all) through
+         ///< 100 (best possible signal). A value of -1 indicates that this
+         ///< device has no concept of a "signal strength".
+  virtual int SignalQuality(void) const;
+         ///< Returns the "quality" of the currently received signal.
+         ///< This is a value in the range 0 (worst quality) through
+         ///< 100 (best possible quality). A value of -1 indicates that this
+         ///< device has no concept of a "signal quality".
   virtual const cChannel *GetCurrentlyTunedTransponder(void) const;
          ///< Returns a pointer to the currently tuned transponder.
          ///< This is not one of the channels in the global cChannels list, but rather
diff -ruN vdr-1.7.18/diseqc.c vdr-1.7.19/diseqc.c
--- vdr-1.7.18/diseqc.c	2010-02-06 16:43:31.000000000 +0100
+++ vdr-1.7.19/diseqc.c	2011-05-22 12:36:12.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.c 2.2 2010/02/06 15:43:31 kls Exp $
+ * $Id: diseqc.c 2.4 2011/05/22 10:36:12 kls Exp $
  */
 
 #include "diseqc.h"
@@ -59,7 +59,7 @@
         polarization = char(toupper(polarization));
         if (polarization == 'V' || polarization == 'H' || polarization == 'L' || polarization == 'R') {
            parsing = true;
-           char *CurrentAction = NULL;
+           const char *CurrentAction = NULL;
            while (Execute(&CurrentAction) != daNone)
                  ;
            parsing = false;
@@ -75,7 +75,7 @@
   return result;
 }
 
-char *cDiseqc::Wait(char *s)
+const char *cDiseqc::Wait(const char *s) const
 {
   char *p = NULL;
   errno = 0;
@@ -89,19 +89,22 @@
   return NULL;
 }
 
-char *cDiseqc::Codes(char *s)
+const char *cDiseqc::Codes(const char *s) const
 {
-  char *e = strchr(s, ']');
+  const char *e = strchr(s, ']');
   if (e) {
-     numCodes = 0;
-     char *t = s;
-     char *p = s;
+     int NumCodes = 0;
+     const char *t = s;
+     char *p;
      while (t < e) {
-           if (numCodes < MaxDiseqcCodes) {
+           if (NumCodes < MaxDiseqcCodes) {
               errno = 0;
               int n = strtol(t, &p, 16);
               if (!errno && p != t && 0 <= n && n <= 255) {
-                 codes[numCodes++] = uchar(n);
+                 if (parsing) {
+                    codes[NumCodes++] = uchar(n);
+                    numCodes = NumCodes;
+                    }
                  t = skipspace(p);
                  }
               else {
@@ -121,7 +124,7 @@
   return NULL;
 }
 
-cDiseqc::eDiseqcActions cDiseqc::Execute(char **CurrentAction)
+cDiseqc::eDiseqcActions cDiseqc::Execute(const char **CurrentAction) const
 {
   if (!*CurrentAction)
      *CurrentAction = commands;
@@ -146,10 +149,10 @@
 
 cDiseqcs Diseqcs;
 
-cDiseqc *cDiseqcs::Get(int Device, int Source, int Frequency, char Polarization)
+const cDiseqc *cDiseqcs::Get(int Device, int Source, int Frequency, char Polarization) const
 {
   int Devices = 0;
-  for (cDiseqc *p = First(); p; p = Next(p)) {
+  for (const cDiseqc *p = First(); p; p = Next(p)) {
       if (p->Devices()) {
          Devices = p->Devices();
          continue;
@@ -157,7 +160,7 @@
       if (Devices && !(Devices & (1 << Device - 1)))
          continue;
       if (p->Source() == Source && p->Slof() > Frequency && p->Polarization() == toupper(Polarization))
-        return p;
+         return p;
       }
   return NULL;
 }
diff -ruN vdr-1.7.18/diseqc.h vdr-1.7.19/diseqc.h
--- vdr-1.7.18/diseqc.h	2010-02-06 16:14:42.000000000 +0100
+++ vdr-1.7.19/diseqc.h	2011-05-22 12:35:38.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: diseqc.h 2.1 2010/02/06 15:14:42 kls Exp $
+ * $Id: diseqc.h 2.2 2011/05/22 10:35:38 kls Exp $
  */
 
 #ifndef __DISEQC_H
@@ -33,15 +33,15 @@
   int lof;
   char *commands;
   bool parsing;
-  uchar codes[MaxDiseqcCodes];
-  int numCodes;
-  char *Wait(char *s);
-  char *Codes(char *s);
+  mutable uchar codes[MaxDiseqcCodes];
+  mutable int numCodes;
+  const char *Wait(const char *s) const;
+  const char *Codes(const char *s) const;
 public:
   cDiseqc(void);
   ~cDiseqc();
   bool Parse(const char *s);
-  eDiseqcActions Execute(char **CurrentAction);
+  eDiseqcActions Execute(const char **CurrentAction) const;
       // Parses the DiSEqC commands and returns the appropriate action code
       // with every call. CurrentAction must be the address of a character pointer,
       // which is initialized to NULL. This pointer is used internally while parsing
@@ -55,12 +55,12 @@
   char Polarization(void) const { return polarization; }
   int Lof(void) const { return lof; }
   const char *Commands(void) const { return commands; }
-  uchar *Codes(int &NumCodes) { NumCodes = numCodes; return numCodes ? codes : NULL; }
+  const uchar *Codes(int &NumCodes) const { NumCodes = numCodes; return numCodes ? codes : NULL; }
   };
 
 class cDiseqcs : public cConfig<cDiseqc> {
 public:
-  cDiseqc *Get(int Device, int Source, int Frequency, char Polarization);
+  const cDiseqc *Get(int Device, int Source, int Frequency, char Polarization) const;
   };
 
 extern cDiseqcs Diseqcs;
diff -ruN vdr-1.7.18/dvbdevice.c vdr-1.7.19/dvbdevice.c
--- vdr-1.7.18/dvbdevice.c	2010-05-01 11:47:13.000000000 +0200
+++ vdr-1.7.19/dvbdevice.c	2011-06-11 16:34:24.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.c 2.38 2010/05/01 09:47:13 kls Exp $
+ * $Id: dvbdevice.c 2.42 2011/06/11 14:34:24 kls Exp $
  */
 
 #include "dvbdevice.h"
@@ -253,12 +253,15 @@
 
 // --- cDvbTuner -------------------------------------------------------------
 
+#define TUNER_POLL_TIMEOUT  10 // ms
+
 class cDvbTuner : public cThread {
 private:
   enum eTunerStatus { tsIdle, tsSet, tsTuned, tsLocked };
   int device;
   int fd_frontend;
   int adapter, frontend;
+  uint32_t subsystemId;
   int tuneTimeout;
   int lockTimeout;
   time_t lastTimeoutReport;
@@ -269,16 +272,20 @@
   cMutex mutex;
   cCondVar locked;
   cCondVar newSet;
-  bool GetFrontendStatus(fe_status_t &Status, int TimeoutMs = 0);
+  void ClearEventQueue(void) const;
+  bool GetFrontendStatus(fe_status_t &Status) const;
   bool SetFrontend(void);
   virtual void Action(void);
 public:
   cDvbTuner(int Device, int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType);
   virtual ~cDvbTuner();
   const cChannel *GetTransponder(void) const { return &channel; }
+  uint32_t SubsystemId(void) const { return subsystemId; }
   bool IsTunedTo(const cChannel *Channel) const;
   void Set(const cChannel *Channel);
   bool Locked(int TimeoutMs = 0);
+  int GetSignalStrength(void) const;
+  int GetSignalQuality(void) const;
   };
 
 cDvbTuner::cDvbTuner(int Device, int Fd_Frontend, int Adapter, int Frontend, fe_delivery_system FrontendType)
@@ -288,6 +295,7 @@
   adapter = Adapter;
   frontend = Frontend;
   frontendType = FrontendType;
+  subsystemId = cDvbDeviceProbe::GetSubsystemId(adapter, frontend);
   tuneTimeout = 0;
   lockTimeout = 0;
   lastTimeoutReport = 0;
@@ -339,16 +347,19 @@
   return tunerStatus >= tsLocked;
 }
 
-bool cDvbTuner::GetFrontendStatus(fe_status_t &Status, int TimeoutMs)
+void cDvbTuner::ClearEventQueue(void) const
 {
-  if (TimeoutMs) {
-     cPoller Poller(fd_frontend);
-     if (Poller.Poll(TimeoutMs)) {
-        dvb_frontend_event Event;
-        while (ioctl(fd_frontend, FE_GET_EVENT, &Event) == 0)
-              ; // just to clear the event queue - we'll read the actual status below
-        }
+  cPoller Poller(fd_frontend);
+  if (Poller.Poll(TUNER_POLL_TIMEOUT)) {
+     dvb_frontend_event Event;
+     while (ioctl(fd_frontend, FE_GET_EVENT, &Event) == 0)
+           ; // just to clear the event queue - we'll read the actual status below
      }
+}
+
+bool cDvbTuner::GetFrontendStatus(fe_status_t &Status) const
+{
+  ClearEventQueue();
   while (1) {
         if (ioctl(fd_frontend, FE_READ_STATUS, &Status) != -1)
            return true;
@@ -358,6 +369,112 @@
   return false;
 }
 
+//#define DEBUG_SIGNALSTRENGTH
+//#define DEBUG_SIGNALQUALITY
+
+int cDvbTuner::GetSignalStrength(void) const
+{
+  ClearEventQueue();
+  uint16_t Signal;
+  while (1) {
+        if (ioctl(fd_frontend, FE_READ_SIGNAL_STRENGTH, &Signal) != -1)
+           break;
+        if (errno != EINTR)
+           return -1;
+        }
+  uint16_t MaxSignal = 0xFFFF; // Let's assume the default is using the entire range.
+  // Use the subsystemId to identify individual devices in case they need
+  // special treatment to map their Signal value into the range 0...0xFFFF.
+  switch (subsystemId) {
+    case 0x13C21019: MaxSignal = 670; break; // TT-budget S2-3200 (DVB-S/DVB-S2)
+    }
+  int s = int(Signal) * 100 / MaxSignal;
+  if (s > 100)
+     s = 100;
+#ifdef DEBUG_SIGNALSTRENGTH
+  fprintf(stderr, "FE %d/%d: %08X S = %04X %04X %3d%%\n", adapter, frontend, subsystemId, MaxSignal, Signal, s);
+#endif
+  return s;
+}
+
+#define LOCK_THRESHOLD 5 // indicates that all 5 FE_HAS_* flags are set
+
+int cDvbTuner::GetSignalQuality(void) const
+{
+  fe_status_t Status;
+  if (GetFrontendStatus(Status)) {
+     // Actually one would expect these checks to be done from FE_HAS_SIGNAL to FE_HAS_LOCK, but some drivers (like the stb0899) are broken, so FE_HAS_LOCK is the only one that (hopefully) is generally reliable...
+     if ((Status & FE_HAS_LOCK) == 0) {
+        if ((Status & FE_HAS_SIGNAL) == 0)
+           return 0;
+        if ((Status & FE_HAS_CARRIER) == 0)
+           return 1;
+        if ((Status & FE_HAS_VITERBI) == 0)
+           return 2;
+        if ((Status & FE_HAS_SYNC) == 0)
+           return 3;
+        return 4;
+        }
+     bool HasSnr = true;
+     uint16_t Snr;
+     while (1) {
+           if (ioctl(fd_frontend, FE_READ_SNR, &Snr) != -1)
+              break;
+           if (errno == EOPNOTSUPP) {
+              Snr = 0xFFFF;
+              HasSnr = false;
+              break;
+              }
+           if (errno != EINTR)
+              return -1;
+           }
+     bool HasBer = true;
+     uint32_t Ber;
+     while (1) {
+           if (ioctl(fd_frontend, FE_READ_BER, &Ber) != -1)
+              break;
+           if (errno == EOPNOTSUPP) {
+              Ber = 0;
+              HasBer = false;
+              break;
+              }
+           if (errno != EINTR)
+              return -1;
+           }
+     bool HasUnc = true;
+     uint32_t Unc;
+     while (1) {
+           if (ioctl(fd_frontend, FE_READ_UNCORRECTED_BLOCKS, &Unc) != -1)
+              break;
+           if (errno == EOPNOTSUPP) {
+              Unc = 0;
+              HasUnc = false;
+              break;
+              }
+           if (errno != EINTR)
+              return -1;
+           }
+     uint16_t MaxSnr = 0xFFFF; // Let's assume the default is using the entire range.
+     // Use the subsystemId to identify individual devices in case they need
+     // special treatment to map their Snr value into the range 0...0xFFFF.
+     switch (subsystemId) {
+       case 0x13C21019: MaxSnr = 200; break; // TT-budget S2-3200 (DVB-S/DVB-S2)
+       }
+     int a = int(Snr) * 100 / MaxSnr;
+     int b = 100 - (Unc * 10 + (Ber / 256) * 5);
+     if (b < 0)
+        b = 0;
+     int q = LOCK_THRESHOLD + a * b * (100 - LOCK_THRESHOLD) / 100 / 100;
+     if (q > 100)
+        q = 100;
+#ifdef DEBUG_SIGNALQUALITY
+     fprintf(stderr, "FE %d/%d: %08X Q = %04X %04X %5d %5d %3d%%\n", adapter, frontend, subsystemId, MaxSnr, Snr, HasBer ? int(Ber) : -1, HasUnc ? int(Unc) : -1, q);
+#endif
+     return q;
+     }
+  return -1;
+}
+
 static unsigned int FrequencyToHz(unsigned int f)
 {
   while (f && f < 1000000)
@@ -392,11 +509,11 @@
   if (frontendType == SYS_DVBS || frontendType == SYS_DVBS2) {
      unsigned int frequency = channel.Frequency();
      if (Setup.DiSEqC) {
-        cDiseqc *diseqc = Diseqcs.Get(device, channel.Source(), channel.Frequency(), dtp.Polarization());
+        const cDiseqc *diseqc = Diseqcs.Get(device, channel.Source(), channel.Frequency(), dtp.Polarization());
         if (diseqc) {
            if (diseqc->Commands() && (!diseqcCommands || strcmp(diseqcCommands, diseqc->Commands()) != 0)) {
               cDiseqc::eDiseqcActions da;
-              for (char *CurrentAction = NULL; (da = diseqc->Execute(&CurrentAction)) != cDiseqc::daNone; ) {
+              for (const char *CurrentAction = NULL; (da = diseqc->Execute(&CurrentAction)) != cDiseqc::daNone; ) {
                   switch (da) {
                     case cDiseqc::daNone:      break;
                     case cDiseqc::daToneOff:   CHECK(ioctl(fd_frontend, FE_SET_TONE, SEC_TONE_OFF)); break;
@@ -407,7 +524,7 @@
                     case cDiseqc::daMiniB:     CHECK(ioctl(fd_frontend, FE_DISEQC_SEND_BURST, SEC_MINI_B)); break;
                     case cDiseqc::daCodes: {
                          int n = 0;
-                         uchar *codes = diseqc->Codes(n);
+                         const uchar *codes = diseqc->Codes(n);
                          if (codes) {
                             struct dvb_diseqc_master_cmd cmd;
                             cmd.msg_len = min(n, int(sizeof(cmd.msg)));
@@ -504,9 +621,9 @@
      SETCMD(DTV_FREQUENCY, FrequencyToHz(channel.Frequency()));
      SETCMD(DTV_INVERSION, dtp.Inversion());
      SETCMD(DTV_MODULATION, dtp.Modulation());
-     
+
      tuneTimeout = ATSC_TUNE_TIMEOUT;
-     lockTimeout = ATSC_LOCK_TIMEOUT;     
+     lockTimeout = ATSC_LOCK_TIMEOUT;
      }
   else {
      esyslog("ERROR: attempt to set channel with unknown DVB frontend type");
@@ -527,7 +644,7 @@
   fe_status_t Status = (fe_status_t)0;
   while (Running()) {
         fe_status_t NewStatus;
-        if (GetFrontendStatus(NewStatus, 10))
+        if (GetFrontendStatus(NewStatus))
            Status = NewStatus;
         cMutexLock MutexLock(&mutex);
         switch (tunerStatus) {
@@ -936,7 +1053,7 @@
   bool hasPriority = Priority < 0 || Priority > this->Priority();
   bool needsDetachReceivers = false;
 
-  if (ProvidesTransponder(Channel)) {
+  if (dvbTuner && ProvidesTransponder(Channel)) {
      result = hasPriority;
      if (Priority >= 0 && Receiving(true)) {
         if (dvbTuner->IsTunedTo(Channel)) {
@@ -969,19 +1086,30 @@
   return numProvidedSystems;
 }
 
+int cDvbDevice::SignalStrength(void) const
+{
+  return dvbTuner ? dvbTuner->GetSignalStrength() : -1;
+}
+
+int cDvbDevice::SignalQuality(void) const
+{
+  return dvbTuner ? dvbTuner->GetSignalQuality() : -1;
+}
+
 const cChannel *cDvbDevice::GetCurrentlyTunedTransponder(void) const
 {
-  return dvbTuner->GetTransponder(); 
+  return dvbTuner ? dvbTuner->GetTransponder() : NULL;
 }
 
 bool cDvbDevice::IsTunedToTransponder(const cChannel *Channel)
 {
-  return dvbTuner->IsTunedTo(Channel);
+  return dvbTuner ? dvbTuner->IsTunedTo(Channel) : false;
 }
 
 bool cDvbDevice::SetChannelDevice(const cChannel *Channel, bool LiveView)
 {
-  dvbTuner->Set(Channel);
+  if (dvbTuner)
+     dvbTuner->Set(Channel);
   return true;
 }
 
@@ -1036,3 +1164,24 @@
 {
   DvbDeviceProbes.Del(this, false);
 }
+
+uint32_t cDvbDeviceProbe::GetSubsystemId(int Adapter, int Frontend)
+{
+  cString FileName;
+  cReadLine ReadLine;
+  FILE *f = NULL;
+  uint32_t SubsystemId = 0;
+  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_vendor", Adapter, Frontend);
+  if ((f = fopen(FileName, "r")) != NULL) {
+     if (char *s = ReadLine.Read(f))
+        SubsystemId = strtoul(s, NULL, 0) << 16;
+     fclose(f);
+     }
+  FileName = cString::sprintf("/sys/class/dvb/dvb%d.frontend%d/device/subsystem_device", Adapter, Frontend);
+  if ((f = fopen(FileName, "r")) != NULL) {
+     if (char *s = ReadLine.Read(f))
+        SubsystemId |= strtoul(s, NULL, 0);
+     fclose(f);
+     }
+  return SubsystemId;
+}
diff -ruN vdr-1.7.18/dvbdevice.h vdr-1.7.19/dvbdevice.h
--- vdr-1.7.18/dvbdevice.h	2010-04-11 12:29:37.000000000 +0200
+++ vdr-1.7.19/dvbdevice.h	2011-06-02 15:20:05.000000000 +0200
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: dvbdevice.h 2.14 2010/04/11 10:29:37 kls Exp $
+ * $Id: dvbdevice.h 2.15 2011/06/02 13:20:05 kls Exp $
  */
 
 #ifndef __DVBDEVICE_H
@@ -141,6 +141,8 @@
   virtual bool ProvidesTransponder(const cChannel *Channel) const;
   virtual bool ProvidesChannel(const cChannel *Channel, int Priority = -1, bool *NeedsDetachReceivers = NULL) const;
   virtual int NumProvidedSystems(void) const;
+  virtual int SignalStrength(void) const;
+  virtual int SignalQuality(void) const;
   virtual const cChannel *GetCurrentlyTunedTransponder(void) const;
   virtual bool IsTunedToTransponder(const cChannel *Channel);
 protected:
@@ -196,6 +198,7 @@
 public:
   cDvbDeviceProbe(void);
   virtual ~cDvbDeviceProbe();
+  static uint32_t GetSubsystemId(int Adapter, int Frontend);
   virtual bool Probe(int Adapter, int Frontend) = 0;
      ///< Probes for a DVB device at the given Adapter and creates the appropriate
      ///< object derived from cDvbDevice if applicable.
diff -ruN vdr-1.7.18/libsi/descriptor.c vdr-1.7.19/libsi/descriptor.c
--- vdr-1.7.18/libsi/descriptor.c	2010-11-01 16:24:31.000000000 +0100
+++ vdr-1.7.19/libsi/descriptor.c	2011-06-15 23:26:00.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.c 2.1 2010/11/01 15:24:31 kls Exp $
+ *   $Id: descriptor.c 2.2 2011/06/15 21:26:00 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -643,6 +643,33 @@
    textualServiceIdentifier.setData(data+sizeof(descr_service_identifier), getLength()-sizeof(descr_service_identifier));
 }
 
+void ContentIdentifierDescriptor::Parse() {
+   identifierLoop.setData(data+sizeof(descr_content_identifier), getLength()-sizeof(descr_content_identifier));
+}
+
+void ContentIdentifierDescriptor::Identifier::Parse() {
+   int offset=0;
+   data.setPointerAndOffset<const content_identifier_entry>(s, offset);
+   if (s->crid_location == 0) {
+     identifier.setData(data+(offset-1), s->crid_length);
+   }
+   else {
+      identifier.setData(data+(offset-1), 2);
+   }
+}
+
+int ContentIdentifierDescriptor::Identifier::getCridType() const {
+   return s->crid_type;
+}
+
+int ContentIdentifierDescriptor::Identifier::getCridLocation() const {
+   return s->crid_location;
+}
+
+void DefaultAuthorityDescriptor::Parse() {
+   DefaultAuthority.setData(data+sizeof(descr_default_authority), getLength()-sizeof(descr_default_authority));
+}
+
 void MultilingualNameDescriptor::Parse() {
    nameLoop.setData(data+sizeof(descr_multilingual_network_name), getLength()-sizeof(descr_multilingual_network_name));
 }
diff -ruN vdr-1.7.18/libsi/descriptor.h vdr-1.7.19/libsi/descriptor.h
--- vdr-1.7.18/libsi/descriptor.h	2010-11-01 16:24:32.000000000 +0100
+++ vdr-1.7.19/libsi/descriptor.h	2011-06-15 23:26:00.000000000 +0200
@@ -6,7 +6,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: descriptor.h 2.1 2010/11/01 15:24:32 kls Exp $
+ *   $Id: descriptor.h 2.2 2011/06/15 21:26:00 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -360,6 +360,31 @@
 protected:
    virtual void Parse();
 };
+
+class ContentIdentifierDescriptor : public Descriptor {
+public:
+   class Identifier : public LoopElement {
+   public:
+      String identifier;
+      int getCridType() const;
+      int getCridLocation() const;
+      virtual int getLength() { return sizeof(content_identifier_entry)+identifier.getLength(); }
+   protected:
+      virtual void Parse();
+   private:
+      const content_identifier_entry *s;
+   };
+   StructureLoop<Identifier> identifierLoop;
+protected:
+   virtual void Parse();
+};
+
+class DefaultAuthorityDescriptor : public Descriptor {
+public:
+   String DefaultAuthority; //ID
+protected:
+   virtual void Parse();
+};
 
 //abstract base class
 class MultilingualNameDescriptor : public Descriptor {
diff -ruN vdr-1.7.18/libsi/headers.h vdr-1.7.19/libsi/headers.h
--- vdr-1.7.18/libsi/headers.h	2010-11-01 16:24:32.000000000 +0100
+++ vdr-1.7.19/libsi/headers.h	2011-06-15 23:26:00.000000000 +0200
@@ -10,7 +10,7 @@
  *   the Free Software Foundation; either version 2 of the License, or     *
  *   (at your option) any later version.                                   *
  *                                                                         *
- *   $Id: headers.h 2.1 2010/11/01 15:24:32 kls Exp $
+ *   $Id: headers.h 2.2 2011/06/15 21:26:00 kls Exp $
  *                                                                         *
  ***************************************************************************/
 
@@ -1680,6 +1680,24 @@
    u_char descriptor_length                      :8;
 };
 
+struct content_identifier_entry {
+#if BYTE_ORDER == BIG_ENDIAN
+   u_char crid_type                              :6;
+   u_char crid_location                          :2;
+#else
+   u_char crid_location                          :2;
+   u_char crid_type                              :6;
+#endif
+  union {
+    u_char crid_length                           :8;
+    u_char crid_ref_hi                           :8;
+  };
+  union {
+    u_char crid_byte                             :8;
+    u_char crid_ref_lo                           :8;
+  };
+};
+
 /* 0x77 time_slice_fec_identifier_descriptor (ETSI EN 301 192) */
 
 struct descr_time_slice_fec_identifier {
